package ch.zhaw.projekt2.turnierverwaltung;

import javafx.scene.control.Labeled;
import javafx.scene.control.MenuItem;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LanguageConfigurator {

    private Language selectedLanguage;
    private Map<String,String> germanDictionary;
    private Map<String,String> englishDictionary;
    private List<Labeled> labelList;
    private List<MenuItem> menuItemList;

    public LanguageConfigurator() {
        selectedLanguage = Language.GERMAN;
        labelList = new ArrayList<>();
        menuItemList = new ArrayList<>();
        germanDictionary = new HashMap<>();
        englishDictionary = new HashMap<>();
        setUpDictionaries();
    }

    private void setUpDictionaries() {
        //Main
        germanDictionary.put("menuItemLanguage","Sprache");
        englishDictionary.put("menuItemLanguage","Language");
        germanDictionary.put("closeBtn","Beenden");
        englishDictionary.put("closeBtn","Close");
        germanDictionary.put("mainTitle","Turnier Manager");
        englishDictionary.put("mainTitle","Tournament Manager");
        //Tournamentlist
        germanDictionary.put("tournamentListTitle","Bestehende Turniere");
        englishDictionary.put("tournamentListTitle","Existing tournaments");
        germanDictionary.put("openBtn","Oeffnen");
        englishDictionary.put("openBtn","Open");
        germanDictionary.put("deleteBtn","Loeschen");
        englishDictionary.put("deleteBtn","Delete");
        germanDictionary.put("newTournamentFormularTitle","Neues Turnier erstellen");
        englishDictionary.put("newTournamentFormularTitle","Create new tournament");
        germanDictionary.put("tournamentNameLabel","Turnier Name:");
        englishDictionary.put("tournamentNameLabel","Tournament Name:");
        germanDictionary.put("tournamentModLabel","Turnier Modus:");
        englishDictionary.put("tournamentModLabel","Tournament Mode:");
        germanDictionary.put("createBtn","Erstellen");
        englishDictionary.put("createBtn","Create");
        //PlaceList
        germanDictionary.put("placeListTitle","Hinzugefuegt");
        englishDictionary.put("placeListTitle","Added");
        germanDictionary.put("saveBtn","Speichern");
        englishDictionary.put("saveBtn","Save");
        germanDictionary.put("newPlaceTitle","Ort aendern/erstellen");
        englishDictionary.put("newPlaceTitle","Create/Change Location");
        germanDictionary.put("placeNameLabel","Ort:");
        englishDictionary.put("placeNameLabel","Location:");
        //GameSchedule
        germanDictionary.put("treeView","Baumansicht");
        englishDictionary.put("treeView","Treeview");
        germanDictionary.put("createScheduleBtn","Spielplan erstellen");
        englishDictionary.put("createScheduleBtn","Create game schedule");
        germanDictionary.put("editParticipantBtn","Teilnehmer bearbeiten");
        englishDictionary.put("editParticipantBtn","Edit Participants");
        germanDictionary.put("editLocBtn","Orte bearbeiten");
        englishDictionary.put("editLocBtn","Edit Locations");
        germanDictionary.put("closeTournamentBtn","Turnier schliessen");
        englishDictionary.put("closeTournamentBtn","Close tournament");
        //ParticipantFormular
        germanDictionary.put("participantListTitle","Hinzugefuegt");
        englishDictionary.put("participantListTitle","Added");
        germanDictionary.put("newParticipantFormularTitle","Teilnehmer aendern/erstellen");
        englishDictionary.put("newParticipantFormularTitle","Change/Create Participant");
        germanDictionary.put("participantNameLabel","Name:");
        englishDictionary.put("participantNameLabel","Name:");
        germanDictionary.put("firstNameLabel","Vorname:");
        englishDictionary.put("firstNameLabel","First Name:");
        germanDictionary.put("phoneNumberLabel","Telefon:");
        englishDictionary.put("phoneNumberLabel","Phone:");
        germanDictionary.put("birthDateLabel","Geb. Datum:");
        englishDictionary.put("birthDateLabel","Birthdate:");
        //Game
        germanDictionary.put("locationLabel","Ort:");
        englishDictionary.put("locationLabel","Location:");
        //Error
        germanDictionary.put("IOException","Fehler beim lesen der Datei");
        englishDictionary.put("IOException","Could not read file");
        germanDictionary.put("tournamentExists","Turniername vergeben");
        englishDictionary.put("tournamentExists","Tournament exists already");
        germanDictionary.put("invalidName","Name nicht gueltig");
        englishDictionary.put("invalidName","Name not valid");
        germanDictionary.put("invalidMode","Modus nicht gueltig");
        englishDictionary.put("invalidMode","Mode not valid");
        germanDictionary.put("numberParticipant","Anzahl Spieler muss mindestens 4 sein und eine Potenz von 2");
        englishDictionary.put("numberParticipant","Number of players must be greater than 3 and power of 2");
        germanDictionary.put("invalidPhone","Telefonnummer nicht gueltig");
        englishDictionary.put("invalidPhone","Phonenumber not valid");
        germanDictionary.put("invalidDate","Geburtsdatum nicht gueltig");
        englishDictionary.put("invalidDate","Birthdate not valid");
        germanDictionary.put("participantNotExist","Teilnehmer existiert nicht");
        englishDictionary.put("participantNotExist","Participant does not exist");
        germanDictionary.put("placeNotExist","Teilnehmer existiert nicht");
        englishDictionary.put("placeNotExist","Participant does not exist");
        //SaveMsg
        germanDictionary.put("save","Zuletzt gespeichert: ");
        englishDictionary.put("save","Last saved: ");
        //Alert
        germanDictionary.put("yes","Ja");
        englishDictionary.put("yes","Yes");
        germanDictionary.put("no","Nein");
        englishDictionary.put("no","No");
        germanDictionary.put("titleDelete","Entfernen");
        englishDictionary.put("titleDelete","Remove");
        germanDictionary.put("headerDelete","Turnier entfernen?");
        englishDictionary.put("headerDelete","Delete Tournament?");
        germanDictionary.put("contentDelete","Sind Sie sicher, dass sie das Turnier entfernen wollen?\nNach diesem Vorgang kann es nicht wiederhergestellt werden.");
        englishDictionary.put("contentDelete","Are you shure you want to delete the tournament?\nAfter that there is no way to restore.");
        germanDictionary.put("titleSchedule","Neu erstellen");
        englishDictionary.put("titleSchedule","Create new");
        germanDictionary.put("headerSchedule","Spielplan neu erstellen?");
        englishDictionary.put("headerSchedule","Create new Schedule?");
        germanDictionary.put("contentSchedule","Sind Sie sicher, dass Sie den Spielplan neu erstellen moechten?\nAlle Spielfortschritte gehen daraufhin verloren!");
        englishDictionary.put("contentSchedule","Are you shure you want to create a new game schedule?\nAll results will be lost!");
    }

    public void translateGUI() {
        String word = "";
        for (Labeled label : labelList) {
            switch (selectedLanguage) {
                case GERMAN -> {
                    word = germanDictionary.get(label.getId());
                }
                case ENGLISH -> {
                    word = englishDictionary.get(label.getId());
                }
            }
            if(word != null) {
                label.setText(word);
            } else {
                //TODO LOG
            }
        }

        for (MenuItem item : menuItemList) {
            switch (selectedLanguage) {
                case GERMAN -> {
                    word = germanDictionary.get(item.getId());
                }
                case ENGLISH -> {
                    word = englishDictionary.get(item.getId());
                }
            }
            if(word != null) {
                item.setText(word);
            } else {
                //TODO LOG
            }
        }
    }

    public void recieveLabel(Labeled label) {
        if (label != null) {
            labelList.add(label);
        }
    }

    public void recieveMenuItem(MenuItem item) {
        menuItemList.add(item);
    }

    public void changeLanguage(Language language) {
        this.selectedLanguage = language;
        translateGUI();
    }

    public String getSelectedLanguage(String getMsg) {
        String word = "";
        switch (selectedLanguage) {
            case GERMAN -> word = germanDictionary.getOrDefault(getMsg,"check Logs");
            case ENGLISH -> word = englishDictionary.getOrDefault(getMsg,"check Logs");
        }
        if (word.equals("check Logs")) {
            //TODO Log
        }
        return word;
    }

    public enum Language {
        ENGLISH,GERMAN
    }
}
