package ch.zhaw.projekt2.turnierverwaltung;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.mockito.Mockito;

public class GameTest {

    private Game game;

    @Test
    @DisplayName("TestWinner")
    void testWinnerFunction() {
        Participant one = Mockito.mock(Player.class);
        Participant two = Mockito.mock(Player.class);
        game = new Game(one,two);
        game.setPoints1(1);
        Assertions.assertEquals(one,game.getWinner());
        game.setPoints2(2);
        Assertions.assertEquals(two,game.getWinner());
    }

    @Test
    @DisplayName("Test refresh Participant")
    void refreshTest() {
        Participant one = Mockito.mock(Player.class);
        Participant two = Mockito.mock(Player.class);
        Game game1 = new Game(one,two);
        Game game2 = new Game(one,two);
        game = new Game(game1,game2);
        game1.setPoints1(2);
        game2.setPoints2(2);
        Assertions.assertNull(game.getParticipant1());
        Assertions.assertNull(game.getParticipant2());
        game.refreshParticipants();
        Assertions.assertEquals(one,game.getParticipant1());
        Assertions.assertEquals(two,game.getParticipant2());

    }
}
